
import numpy as np

#----------------
# データ入力
#----------------

#節点数の入力
nod = input("Number of node =")
nod = int(nod)
ndg = 1

#座標入力
x = np.zeros(nod)
for i in range(nod):
    x[i] = input("x = ")

#境界条件
idg = np.zeros(nod*ndg, dtype=int)
idg[0]=1

#荷重条件
fg = np.zeros(nod*ndg)
fg[nod-1] = input("Fx = ")

#要素情報
nel = nod-1
nnd = 2
indv = np.zeros((nel,2),dtype=int)
for i in range(nel):
    indv[i][0]=i
    indv[i][1]=i+1

#ヤング係数の入力
E = input("E = ")
E = float(E)

#断面積の入力
A = np.zeros(nel)
for i in range(nel):
    A[i]=input("A = ")

#----------------
# 有限要素解析
#----------------
#全体剛性マトリクスの作成
kg = np.zeros((nod*ndg,nod*ndg))
ke = np.zeros((2,2))
for n in range(nel):
    L = x[indv[n][1]]-x[indv[n][0]]
    ke[0][0] = E*A[n]/L
    ke[0][1] =-E*A[n]/L
    ke[1][0] =-E*A[n]/L
    ke[1][1] = E*A[n]/L
    for i in range(nnd):
        for j in range(nnd):
            ig = indv[n][i]
            jg = indv[n][j]
            kg[ig][jg] = kg[ig][jg] + ke[i][j]

#変位拘束点以外の行列の抽出
ic = -1
for i in range(nod):
    if idg[i] == 0:
        ic = ic + 1
        fg[ic] = fg[i]
        jc = -1
        for j in range(nod):
            if idg[j] == 0:
                jc = jc + 1
                kg[ic][jc] = kg[i][j]

#連立方程式の解法
kgc = np.zeros((ic+1,jc+1))
fgc = np.zeros(ic+1)

for i in range(ic+1):
    fgc[i]=fg[i]
    for j in range(jc+1):
        kgc[i][j]=kg[i][j]

dgc = np.zeros(ic+1)
dgc = np.linalg.solve(kgc, fgc)

#節点変位の出力
dg = np.zeros(nod)
ic = -1
for i in range(nod):
    if idg[i] == 0 :
        ic = ic + 1
        dg[i] = dgc[ic]

print('displacement of node = ',dg)

#要素軸力の計算と出力
Nf = np.zeros(nel)
for n in range(nel):
    Nf[n] = -E*A[n]/L*( dg[indv[n][0]] - dg[indv[n][1]] )

print('N = ',Nf)
