import numpy as np
import math

file = open('input2.txt','r')
fileout = open('output2.txt','w')

#----------------
# データ入力
#----------------
nod = file.readline()
nod = int(nod)
ndg = 2
X = np.zeros(nod)
Y = np.zeros(nod)
idg = np.zeros(nod*ndg,dtype=int)
fg = np.zeros(nod*ndg)
dg = np.zeros(nod*ndg)
kg = np.zeros((nod*ndg,nod*ndg))

#座標入力
for i in range(nod):
   xd = file.readline()
   X[i],Y[i] = xd.split(',')

#拘束情報の入力
ncn = file.readline()
ncn = int(ncn)
for i in range(ncn):
    bcn = file.readline()
    icn,ic1,ic2 = bcn.split(',')
    icn = int(icn)
    idg[ndg*(icn-1)+0] = ic1
    idg[ndg*(icn-1)+1] = ic2

#荷重情報の入力
nld = file.readline()
nld = int(nld)
for i in range(nld):
    fd = file.readline()
    ild,f1,f2 = fd.split(',')
    ild = int(ild)
    fg[ndg*(ild-1)+0] = f1
    fg[ndg*(ild-1)+1] = f2

#*** 要素情報の入力 ***
nel = file.readline()
nel = int(nel)
nnd = 2
indv = np.zeros((nel,nnd),dtype=int)
A = np.zeros(nel)

#要素のi端とj端の節点番号の入力
for i in range(nel):
    ind = file.readline()
    i1,i2 = ind.split(',')
    indv[i][0] = i1
    indv[i][1] = i2
indv = indv - 1

#ヤング係数の入力
E = file.readline()
E = float(E)

#断面積の入力
for i in range(nel):
    A[i] = file.readline()

file.close()

#入力データの出力
tl = 'Nod no.'+'      x      ' + '     y     '+'  bc_x  bc_y   '+'   fx        fy '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nod):
    s = str((' %5d' % (i+1)))+str('  %10.3e' % X[i])+str('  %10.3e' % Y[i])  \
      + str(' %5d' % idg[ndg*i+0]) + str(' %5d' % idg[ndg*i+1])  \
      + str('   %10.3e' % fg[ndg*i+0])+ str(' %10.3e' % fg[ndg*i+1])
    print(s)
    fileout.write(s)
    fileout.write('\n')

fileout.write('\n')
tl = 'Elm no.'+'    i     ' + ' j   '+'    E    '+'      A     '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nel):
    s = str(' %5d' % (i+1)) +str(' %5d' % (indv[i][0]+1)) +str('  %5d' % (indv[i][1]+1)) \
    + str('  %10.3e' % E) + str('  %10.3e' % A[i])
    print(s)
    fileout.write(s)
    fileout.write('\n')

#----------------
# 有限要素解析
#----------------
#全体剛性マトリクスの作成
kg = np.zeros((nod*ndg,nod*ndg))
ke = np.zeros((nnd*ndg,nnd*ndg))

for n in range(nel):
    i1 = indv[n][0]
    i2 = indv[n][1]
    L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
    cs = (X[i2]-X[i1])/L
    sn = (Y[i2]-Y[i1])/L
    ke[0][0] = E*A[n]/L*cs**2
    ke[0][1] = E*A[n]/L*cs*sn
    ke[0][2] =-E*A[n]/L*cs**2
    ke[0][3] =-E*A[n]/L*cs*sn
    ke[1][0] = ke[0][1]
    ke[1][1] = E*A[n]/L*sn**2
    ke[1][2] =-E*A[n]/L*cs*sn
    ke[1][3] =-E*A[n]/L*sn**2
    ke[2][0] = ke[0][2]
    ke[2][1] = ke[1][2]
    ke[2][2] = E*A[n]/L*cs**2
    ke[2][3] = E*A[n]/L*cs*sn
    ke[3][0] = ke[0][3]
    ke[3][1] = ke[1][3]
    ke[3][2] = ke[2][3]
    ke[3][3] = E*A[n]/L*sn**2
    for ip in range(nnd):
        for i in range(ndg):
            ie = ndg*ip+i
            ig = ndg*indv[n][ip]+i
            for jp in range(nnd):
                for j in range(ndg):
                    je = ndg*jp+j
                    jg = ndg*indv[n][jp]+j
                    kg[ig][jg] = kg[ig][jg] + ke[ie][je]

#変位拘束点以外の行列の抽出
ic = 0
for i in range(nod*ndg):
    if idg[i]==0:
        ic = ic+1

kgc = np.zeros((ic,ic))
fgc = np.zeros(ic)
dgc = np.zeros(ic)

ic = -1
for i in range(nod*ndg):
    if idg[i]==0:
        ic = ic+1
        fgc[ic]=fg[i]
        jc = -1
        for j in range(nod*ndg):
            if idg[j]==0:
                jc = jc + 1
                kgc[ic][jc]=kg[i][j]

#連立方程式の解法
dgc = np.linalg.solve(kgc, fgc)

#節点変位の出力
dg = np.zeros(nod*ndg)
ic = -1
for i in range(nod*ndg):
    if idg[i] == 0 :
        ic = ic + 1
        dg[i] = dgc[ic]

fileout.write('\n')
s = '-- displacement --'
print(s)
fileout.write(s)
fileout.write('\n')
tl = 'Nod no.'+'      u      ' + '     v     '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nod):
    s = str(' %5d' % (i+1))+str('  %10.3e' % dg[ndg*i+0])+str('  %10.3e' % dg[ndg*i+1])
    print(s)
    fileout.write(s)
    fileout.write('\n')

#軸力の計算と出力
Nf = np.zeros(nel)
for n in range(nel):
    i1 = indv[n][0]
    i2 = indv[n][1]
    L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
    cs = (X[i2]-X[i1])/L
    sn = (Y[i2]-Y[i1])/L
    ui = cs * dg[ndg * i1 + 0] + sn * dg[ndg * i1 + 1]
    uj = cs * dg[ndg * i2 + 0] + sn * dg[ndg * i2 + 1]
    fxi = E * A[n] / L * (ui - uj)
    Nf[n] = - fxi

s = '-- Stress (N) --'
print(s)
fileout.write(s)
fileout.write('\n')
tl = 'Elm no.'+'      N      '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nel):
    s = str(' %5d' % (i+1)) + str('   %10.3e' % Nf[i])
    print(s)
    fileout.write(s)
    fileout.write('\n')

fileout.close()