import numpy as np
import math

file = open('input3.txt','r')
fileout = open('output3.txt','w')

#----------------
# データ入力
#----------------
nod = file.readline()
nod = int(nod)
ndg = 3
X = np.zeros(nod)
Y = np.zeros(nod)
idg = np.zeros(nod*ndg,dtype=int)
fg = np.zeros(nod*ndg)
dg = np.zeros(nod*ndg)
kg = np.zeros((nod*ndg,nod*ndg))

#座標入力
for i in range(nod):
   xd = file.readline()
   X[i],Y[i] = xd.split(',')

#拘束情報の入力
ncn = file.readline()
ncn = int(ncn)
for i in range(ncn):
    bcn = file.readline()
    icn,ic1,ic2,ic3 = bcn.split(',')
    icn = int(icn)
    idg[ndg*(icn-1)+0] = ic1
    idg[ndg*(icn-1)+1] = ic2
    idg[ndg*(icn-1)+2] = ic3

#荷重情報の入力
nld = file.readline()
nld = int(nld)
for i in range(nld):
    fd = file.readline()
    ild,f1,f2,f3 = fd.split(',')
    ild = int(ild)
    fg[ndg*(ild-1)+0] = f1
    fg[ndg*(ild-1)+1] = f2
    fg[ndg*(ild-1)+2] = f3

#*** 要素情報の入力 ***
nel = file.readline()
nel = int(nel)
nnd = 2
indv = np.zeros((nel,nnd),dtype=int)
A  = np.zeros(nel)
Iz = np.zeros(nel)
Cij = np.zeros(nel)
Cji = np.zeros(nel)
Q0i = np.zeros(nel)
Q0j = np.zeros(nel)
M0  = np.zeros(nel)

#要素のi端とj端の節点番号の入力
for i in range(nel):
    ind = file.readline()
    i1,i2 = ind.split(',')
    indv[i][0] = i1
    indv[i][1] = i2
indv = indv - 1

#ヤング係数の入力
E = file.readline()
E = float(E)

#断面積、断面２次モーメントの入力
for i in range(nel):
    s = file.readline()
    s1,s2 = s.split(',')
    A[i] = s1
    Iz[i] = s2

#要素内荷重の入力
npl = file.readline()
npl = int(npl)
for i in range(npl):
    s = file.readline()
    n,s1,s2,s3,s4,s5 = s.split(',')
    n = int(n)-1
    Cij[n] = s1
    Cji[n] = s2
    Q0i[n] = s3
    Q0j[n] = s4
    M0[n]  = s5
    Q0i[n]=-Q0i[n]
    Q0j[n]=-Q0j[n]
    i1 = indv[n][0]
    i2 = indv[n][1]
    L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
    cs = (X[i2] - X[i1]) / L
    sn = (Y[i2] - Y[i1]) / L
    fg[ndg * i1 + 0]= fg[ndg * i1 + 0] - sn * Q0i[n]
    fg[ndg * i1 + 1] = fg[ndg * i1 + 1] + cs * Q0i[n]
    fg[ndg * i1 + 2] = fg[ndg * i1 + 2] + Cij[n]
    fg[ndg * i2 + 0] = fg[ndg * i2 + 0] - sn * Q0j[n]
    fg[ndg * i2 + 1] = fg[ndg * i2 + 1] + cs * Q0j[n]
    fg[ndg * i2 + 2] = fg[ndg * i2 + 2] + Cji[n]

file.close()

#入力データの出力
tl = 'Nod no.'+'      x      ' + '     y     '+'   bcx   bcy  bcth    '+'    fx         fy         M'
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nod):
    s = str((' %5d' % (i+1)))+str('  %10.3e' % X[i])+str('  %10.3e' % Y[i])  \
      + str(' %5d' % idg[ndg*i+0]) + str(' %5d' % idg[ndg*i+1]) + str(' %5d' % idg[ndg*i+2])  \
      + str('    %10.3e' % fg[ndg*i+0]) + str(' %10.3e' % fg[ndg*i+1]) + str(' %10.3e' % fg[ndg*i+2])
    print(s)
    fileout.write(s)
    fileout.write('\n')

tl = 'Elm no.'+'    i     ' + ' j   '+'    E    '+'       A     '+'      Iz      '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nel):
    s = str(' %5d' % (i+1)) + str(' %5d' % (indv[i][0]+1)) + str('  %5d' % (indv[i][1]+1)) \
    + str('  %10.3e' % E) + str('  %10.3e' % A[i]) + str('  %10.3e' % Iz[i])
    print(s)
    fileout.write(s)
    fileout.write('\n')

tl = 'Elm no.'+'      Cij     ' + '     Cij    '+'    Q0i    '+'     Q0j     '+'    M0      '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nel):
    s = str(' %5d' % (i+1)) + str('  %10.3e' % Cij[i]) + str('  %10.3e' % Cji[i]) \
    + str('  %10.3e' % Q0i[i]) + str('  %10.3e' % Q0j[i]) + str('  %10.3e' % M0[i])
    print(s)
    fileout.write(s)
    fileout.write('\n')

#----------------
# 有限要素解析
#----------------
#全体剛性マトリクスの作成
kg = np.zeros((nod*ndg,nod*ndg))
ke = np.zeros((nnd*ndg,nnd*ndg))
Tr = np.zeros((nnd*ndg,nnd*ndg))
Tke = np.zeros((nnd*ndg,nnd*ndg))
TkT = np.zeros((nnd*ndg,nnd*ndg))

for n in range(nel):
    i1 = indv[n][0]
    i2 = indv[n][1]
    L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
    cs = (X[i2]-X[i1])/L
    sn = (Y[i2]-Y[i1])/L
#座標変換マトリクス
    Tr[0][0] = cs
    Tr[0][1] = sn
    Tr[1][0] = -sn
    Tr[1][1] = cs
    Tr[2][2] = 1.0
    Tr[3][3] = cs
    Tr[3][4] = sn
    Tr[4][3] = -sn
    Tr[4][4] = cs
    Tr[5][5] = 1.0
#要素剛性マトリクス
    cx = E * A[n] / L
    ke[0][0] = cx
    ke[0][3] = -cx
    ke[3][0] = -cx
    ke[3][3] = cx
    cy = E * Iz[n] / L ** 3
    ke[1][1] = 12.0 * cy
    ke[1][2] = 6.0 * L * cy
    ke[1][4] = -12.0 * cy
    ke[1][5] = 6.0 * L * cy
    ke[2][1] = ke[1][2]
    ke[2][2] = 4.0 * L ** 2 * cy
    ke[2][4] = -6.0 * L * cy
    ke[2][5] = 2.0 * L ** 2 * cy
    ke[4][1] = ke[1][4]
    ke[4][2] = ke[2][4]
    ke[4][4] = 12.0 * cy
    ke[4][5] = -6.0 * L * cy
    ke[5][1] = ke[1][5]
    ke[5][2] = ke[2][5]
    ke[5][4] = ke[4][5]
    ke[5][5] = 4.0 * L ** 2 * cy

#座標変換
    Tke = np.dot(Tr.T, ke)
    TkT = np.dot(Tke, Tr)

#全体マトリクスへの重合
    for ip in range(nnd):
        for i in range(ndg):
            ie = ndg*ip+i
            ig = ndg*indv[n][ip]+i
            for jp in range(nnd):
                for j in range(ndg):
                    je = ndg*jp+j
                    jg = ndg*indv[n][jp]+j
                    kg[ig][jg] = kg[ig][jg] + TkT[ie][je]

#変位拘束点以外の行列の抽出
ic = 0
for i in range(nod*ndg):
    if idg[i]==0:
        ic = ic+1

kgc = np.zeros((ic,ic))
fgc = np.zeros(ic)
dgc = np.zeros(ic)

ic = -1
for i in range(nod*ndg):
    if idg[i]==0:
        ic = ic+1
        fgc[ic]=fg[i]
        jc = -1
        for j in range(nod*ndg):
            if idg[j]==0:
                jc = jc + 1
                kgc[ic][jc]=kg[i][j]

#連立方程式の解法
dgc = np.linalg.solve(kgc, fgc)

#節点変位の出力
dg = np.zeros(nod*ndg)
ic = -1
for i in range(nod*ndg):
    if idg[i] == 0 :
        ic = ic + 1
        dg[i] = dgc[ic]

fileout.write('\n')
s = '-- displacement --'
print(s)
fileout.write(s)
fileout.write('\n')
tl = 'Nod no.'+'      u      ' + '     v     '+ '     th     '
print(tl)
fileout.write(tl)
fileout.write('\n')
for i in range(nod):
    s = str(' %5d' % (i+1))+str('  %10.3e' % dg[ndg*i+0])+str('  %10.3e' % dg[ndg*i+1]) \
        +str('  %10.3e' % dg[ndg*i+2])
    print(s)
    fileout.write(s)
    fileout.write('\n')

#応力（断面力）計算と出力

s = '-- Stress --'
print(s)
fileout.write(s)
fileout.write('\n')
tl = 'Elm no.'+'      N           Qi           Qj           Mi           Mj           Mc'
print(tl)
fileout.write(tl)
fileout.write('\n')

for n in range(nel):
    i1 = indv[n][0]
    i2 = indv[n][1]
    L = math.sqrt((X[i2]-X[i1]) ** 2 + (Y[i2]-Y[i1]) ** 2)
    cs = (X[i2]-X[i1])/L
    sn = (Y[i2]-Y[i1])/L
    ui = cs * dg[ndg * i1 + 0] + sn * dg[ndg * i1 + 1]
    uj = cs * dg[ndg * i2 + 0] + sn * dg[ndg * i2 + 1]
    fxi = E * A[n] / L * (ui - uj)
    Nf = - fxi
    vi = -sn * dg[ndg * i1 + 0] + cs * dg[ndg * i1 + 1]
    ti = dg[ndg * i1 + 2]
    vj = -sn * dg[ndg * i2 + 0] + cs * dg[ndg * i2 + 1]
    tj = dg[ndg * i2 + 2]
    cy = E * Iz[n] / L ** 3
    fyi = 12.0 * cy * vi + 6.0 * L * cy * ti - 12.0 * cy * vj + 6.0 * L * cy * tj
    fyj =-12.0 * cy * vi - 6.0 * L * cy * ti + 12.0 * cy * vj - 6.0 * L * cy * tj
    fyi = fyi - Q0i[n]
    fyj = fyj - Q0j[n]
    Qi = fyi
    Qj = -fyj
    mzi = 6.0 * L * cy * vi + 4.0 * L ** 2 * cy * ti - 6.0 * L * cy * vj + 2.0 * L ** 2 * cy * tj
    mzj = 6.0 * L * cy * vi + 2.0 * L ** 2 * cy * ti - 6.0 * L * cy * vj + 4.0 * L ** 2 * cy * tj
    mzi = mzi - Cij[n]
    mzj = mzj - Cji[n]
    Mi = -mzi
    Mj =  mzj
    Mc = M0[n] + (Mi + Mj) / 2.0

    s = str(' %5d' % (n+1)) + str('   %10.3e' % Nf) + str('   %10.3e' % Qi)+ str('   %10.3e' % Qj) \
      + str('   %10.3e' % Mi) + str('   %10.3e' % Mj) + str('   %10.3e' % Mc)
    print(s)
    fileout.write(s)
    fileout.write('\n')